// BroadcastEnvChange.cpp : Defines the entry point for the console application.
//

#pragma once

#include "targetver.h"

#include <Windows.h>
#include <stdio.h>
#include <tchar.h>

// Broadcast the WM_SETTINGCHANGE message for Environment (can take 5 seconds to return)
void envupdate(){
  printf("\nMaking WM_SETTINGCHANGE message for Environment broadcast...\n");
  SendMessageTimeout(HWND_BROADCAST, WM_SETTINGCHANGE, 0,
  (LPARAM) "Environment", SMTO_ABORTIFHUNG, 5000, 0);
  printf("WM_SETTINGCHANGE message for Environment was broadcast\n");
}

void help(){
  printf("BroadcastEnvChange makes a WM_SETTINGCHANGE message for Environment broadcast so that running applications update environment settings\n");
  printf("\nBroadcastEnvChange.exe /broadcast\n");
  printf("/broadcast  : initiates the broadcast\n");
}

int main(int argc,
    char *argv[ ],
    char **envp)
{
   if(argc == 1) 
     help();
   else if(argc == 2)
     {
       if(_stricmp(argv[1], "/broadcast") == 0)
         envupdate();
       else if(_stricmp(argv[1], "/help") == 0 || _stricmp(argv[1], "help") == 0 || _stricmp(argv[1], "-help") == 0 || _stricmp(argv[1], "/?") == 0 || _stricmp(argv[1], "-?") == 0)
         help();
       else
       {
         printf("\nIncorrect parameter was passed\n\n\n");
         help();
       }
     }
   else if(argc <= 3)
     {
       printf("\nToo many parameters were passed\n\n\n");
       help();
     }
}